/*
rls.hh

This C++ header file defines the class RLS_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Sun Dec 17 20:48:05 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef RLS_HH
#define RLS_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rls_estm.hh"  // RLS_ESTM definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "rlsn.hh" 	// NML Commands and Status definitions for rls
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class RLS_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	RLS_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(RLS_INIT *);
	virtual void HALT(RLS_HALT *);
	virtual void ESTIMATE(RLS_ESTIMATE *);
	virtual void SET_COVARIANCE(RLS_SET_COVARIANCE *);
	virtual void SET_LAMBDA(RLS_SET_LAMBDA *);
	virtual void SET_PARAM(RLS_SET_PARAM *);

	// Convenience Variables
	RLS_STATUS *rls_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_of_params;
  RLS_ESTM *rls_estm;
  double *param_estimates;
  double *regression_vector;

  double plant_output;
  double estimated_output;

};

#endif 	// RLS_HH

